Index: distrib/common/Makefile.bootcd
===================================================================
RCS file: /cvsroot/src/distrib/common/Makefile.bootcd,v
retrieving revision 1.12
diff -u -r1.12 Makefile.bootcd
--- distrib/common/Makefile.bootcd	20 Nov 2007 16:12:50 -0000	1.12
+++ distrib/common/Makefile.bootcd	23 Nov 2007 15:31:01 -0000
@@ -15,7 +15,12 @@
 #	CDRELEASE	Set to 'true' to include $RELEASEDIR/$MACHINE on the CD
 #	CDRELEASE_NOISOS Excludes installation/cdrom directory if set
 #	CDSOURCE	Set to 'true' to include $RELEASEDIR/source on the CD
-#	CDEXTRA		Set to a directory containing extra stuff to put on CD
+#	CDEXTRA		Set to a list of files or directories containing extra
+#			stuff to put on CD (set by build.sh -C flag)
+#	CDBUILDEXTRA	Set to a list of files or directories containing extra
+#			stuff to put on CD (use in Makefiles)
+#	CDEXTRA_SKIP	A list of file exclusion paths to exclude when copying
+#			directories of extra stuff in CDEXTRA AND CDBUILDEXTRA
 #	BOOT		Defaults to $DESTDIR/usr/mdec/boot
 #	BOOTXX_CD9660	Defaults to $DESTDIR/usr/mdec/bootxx_cd9660
 #	CDBOOTOPTIONS	Options for installboot, eg -o console=com0,speed=9600
@@ -136,19 +141,35 @@
 			. $$release_destdir; 				\
 		cd $$curdir;						\
 	fi
-	if [ "X${CDEXTRA}" != "X" ]; then 				\
-		if [ ! -d ${CDEXTRA} ]; then	 			\
-			echo "Missing ${CDEXTRA}, aborting"; 		\
-			exit 1; 					\
-		fi; 							\
+	if [ "X${CDEXTRA}${CDBUILDEXTRA}" != "X" ]; then		\
 		curdir=$$(pwd);						\
-		release_destdir=$$(pwd)/cdrom;		 		\
-		cd ${CDEXTRA};		 				\
-		echo Copying $$(pwd) to $$release_destdir ...;		\
-		${TOOL_PAX} 						\
-			-rw -pe -v 					\
-			. $$release_destdir; 				\
-		cd $$curdir;						\
+		skipflag="";						\
+		if [ "X${CDEXTRA_SKIP}" != "X" ]; then			\
+			rm -f cdskip;					\
+			for skip in ${CDEXTRA_SKIP};			\
+			do						\
+				echo $${skip} >> cdskip;		\
+			done;						\
+			skipflag="-X $${curdir}/cdskip";		\
+		fi;							\
+		for cde in ${CDEXTRA} ${CDBUILDEXTRA};			\
+		do							\
+			release_destdir=$${curdir}/cdrom;		\
+			if [ -f $${cde} ]; then				\
+				echo Copying $${cde} to $$release_destdir ...;	\
+				${CP} $${cde} $${release_destdir};	\
+			elif [ -d $${cde} ]; then			\
+				cd $${cde};				\
+				echo Copying $$(pwd) to $$release_destdir ...;	\
+				${TOOL_MTREE} -c $${skipflag} |		\
+					${TOOL_PAX} -rw -pe -v -M	\
+					$$release_destdir; 		\
+			else						\
+				echo "Missing $${cde}, aborting"; 	\
+				exit 1; 				\
+			fi; 						\
+			cd $$curdir;					\
+		done;							\
 	fi
 
 image:
Index: distrib/i386/cdroms/installcd/Makefile
===================================================================
RCS file: /cvsroot/src/distrib/i386/cdroms/installcd/Makefile,v
retrieving revision 1.3
diff -u -r1.3 Makefile
--- distrib/i386/cdroms/installcd/Makefile	8 Mar 2007 13:48:36 -0000	1.3
+++ distrib/i386/cdroms/installcd/Makefile	23 Nov 2007 15:31:01 -0000
@@ -8,5 +8,10 @@
 
 CDBASE=		i386cd			# gives ${CDBASE}.iso
 CDRELEASE=      true                    # include $RELEASEDIR/$MACHINE
+CDBUILDEXTRA=	boot.cfg		# Add boot.cfg file
+CLEANFILES+=	boot.cfg
+
+prepare_md_post:
+	${TOOL_SED} "s/@@VERSION@@/${DISTRIBVER}/" < ${.CURDIR}/boot.cfg.in > boot.cfg
 
 .include "${.CURDIR}/../../../common/Makefile.bootcd"
--- /dev/null	2007-11-23 14:17:57.000000000 +0000
+++ distrib/i386/cdroms/installcd/boot.cfg.in	2007-11-23 15:25:34.000000000 +0000
@@ -0,0 +1,11 @@
+banner=Welcome to the NetBSD @@VERSION@@ installation CD
+banner================================================================================
+banner=
+banner=The default ACPI kernel should work on all modern and legacy hardware, however
+banner=if you have problems, please try the kernel without ACPI.
+banner=
+banner=Please report issues on hardware manufactured after 1998 with the ACPI kernel.
+menu=Install NetBSD (standard ACPI kernel):boot netbsd
+menu=Install NetBSD (no ACPI):boot nbnoacpi
+menu=Drop to boot prompt:prompt
+timeout=10
